require 'helper'

describe 'entity references' do

  subject { EntityReferences.new }
  let(:id) { 43 }
  let(:object_id) { 42 }
  let(:entity) { Struct.new(:object_id).new(object_id) }

  describe 'save' do
    it 'returns the passed id' do
      assert_equal id, subject.save(id, entity)
    end
  end

  describe 'find' do
    it 'returns the passed id' do
      subject.save(id, entity)
      assert_equal id, subject.find(entity)
    end
  end

  describe 'remove' do
    it 'returns the passed id' do
      subject.save(id, entity)
      assert_equal id, subject.remove(entity)
    end
  end

  describe 'integration' do
    it 'saves an entity, finds it and removes it after that' do
      subject.save(id, entity)
      assert_equal id, subject.find(entity)
      subject.remove(entity)
      assert_nil subject.find(entity)
    end
  end

end
