require 'helper'

describe Resolver do

  let(:subject_class) { Class.new { include Resolver } }
  subject { subject_class.new }

  # entites
  let(:foo) { faked_class('Foo').new }
  let(:bar) { faked_class('Nested::Bar').new }

  it 'extracts entity class name from Store::Ref' do
    ref = Store::Ref.new('Foo', 42)
    assert_equal 'Foo', subject.extract_entity_class_name_from_ref(ref)
  end

  it 'extracts entity class name from Store::Query' do
    query = Store::Query.new('Foo', :query_name, :some, :args)
    assert_equal 'Foo', subject.extract_entity_class_name_from_query(query)
  end

  it 'extracts entity class name from Object' do
    assert_equal 'Foo', subject.extract_entity_class_name_from_object(foo)
  end

  it 'extracts entity class from Nested::Object' do
    assert_equal 'Bar', subject.extract_entity_class_name_from_object(bar)
  end

end
